// EventDisasm.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "EventDisasm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;
CTypedPtrArray<CPtrArray, DialogueItem*> dialogue;
Item items[256];
Esper espers[27];
Character characters[64];

CString g_strColorComponents[] =
{
	"None", "None",
	"Red", "Red",
	"Green", "Green",
	"Yellow [Red + Green]", "Yellow [Red + Green]",
	"Blue", "Blue",
	"Magenta [Red + Blue]", "Magenta [Red + Blue]",
	"Cyan [Green + Blue]", "Cyan [Green + Blue]",
	"White [Red + Green + Blue]", "White [Red + Green + Blue]",
};

void realMain();
void readDialogue(CFile* m_pFile);

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		realMain();

		for(int i = 0; i < dialogue.GetSize(); i++)
			delete dialogue[i];
		dialogue.RemoveAll();
	}

	return nRetCode;
}

void realMain()
{
	CFile file;  file.Open("C:\\Games\\zsnes800\\FF3.SMC", CFile::modeRead);
	ofstream outFile;  outFile.open("C:\\Games\\zsnes800\\eventdump.txt");

	readDialogue(&file);

	DWORD dwOffset = 0;
	DWORD pc;
	DWORD dwQueueStart = 0;
	BYTE bQueueLen = 0;

	CString t;
	BYTE b[16];
	WORD w[16];
	DWORD d[16];
	CString s[16];
	BOOL bFirst;
	int nChoices = 0;
	int x, y;

	file.Seek(0xA0200, CFile::begin);

	while(dwOffset < 0xCE800)
	{
		for(int i = 0; i < 16; i++)
		{
			b[i] = w[i] = d[i] = 0;
			s[i].Empty();
		}

		bFirst = TRUE;

		dwOffset = file.GetPosition();
		pc = dwOffset + 0xC00000 - 0x200;

		dwQueueStart = 0;
		bQueueLen = 0;

		// Read the opcode.
		BYTE opcode = 0;
		file.Read(&opcode, 1);
		
		t.Format("%02X/%04X: %02X    ", (pc & 0xFF0000) >> 16, pc & 0xFFFF, opcode);
		outFile << t;

		switch(opcode)
		{
			case 0x35:
				file.Read(b, 1);
				t.Format("Command $35, $%02X", b[0]);
				outFile << t;
				break;
			case 0x36:
				file.Read(b, 1);
				t.Format("Command $36, $%02X", b[0]);
				outFile << t;
				break;
			case 0x37:
				file.Read(b, 2);

				if(b[0] >= 0x00 && b[0] < 0x10)
					s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
				else if(b[0] >= 0x10 && b[0] <= 0x30)
					s[0].Format("NPC $%02X", b[0]);
				else if(b[0] >= 0x31 && b[0] <= 0x34)
					s[0].Format("Party Character %d", b[0] - 0x31);
				else
					s[0] = "<Invalid Character>";

				t.Format("Assign graphics $%02X to object $%02X (%s)", b[1], b[0], s[0]);
				outFile << t;
				break;
			case 0x38:
				outFile << "Hold screen";
				break;
			case 0x39:
				outFile << "Free screen";
				break;
			case 0x3A:
				outFile << "Command $3A";
				break;
			case 0x3B:
				outFile << "Position character in a \"ready-to-go\" stance";
				break;
			case 0x3C:
				file.Read(b, 4);

				for(x = 0; x < 4; x++)
				{
					if(b[x] >= 0x00 && b[x] < 0x10)
						s[x] = FixedTextToCString(characters[b[x]].name, 6, TAG_END, 0);
					else if(b[x] >= 0x10 && b[x] <= 0x30)
						s[x].Format("NPC $%02X", b[x]);
					else if(b[x] >= 0x31 && b[x] <= 0x34)
						s[x].Format("Party Character %d", b[x] - 0x31);
					else
						s[x] = "<Invalid Character>";
				}

				t.Format("Add the following characters to the party: $%02X (%s), $%02X (%s), $%02X (%s), $%02X (%s)", b[0], s[0], b[1], s[1], b[2], s[2], b[3], s[3]);
				outFile << t;
				break;
			case 0x3D:
				file.Read(b, 1);
				t.Format("Create object $%02X", b[0]);
				outFile << t;
				break;
			case 0x3E:
				file.Read(b, 1);
				t.Format("Delete object $%02X", b[0]);
				outFile << t;
				break;
			case 0x3F:
				file.Read(b, 2);

				if(b[0] >= 0x00 && b[0] < 0x10)
					s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
				else if(b[0] >= 0x10 && b[0] <= 0x30)
					s[0].Format("NPC $%02X", b[0]);
				else if(b[0] >= 0x31 && b[0] <= 0x34)
					s[0].Format("Party Character %d", b[0] - 0x31);
				else
					s[0] = "<Invalid Character>";

				if(b[1] != 0)
					t.Format("Assign character $%02X (%s) to party %d", b[0], s[0], b[1]);
				else
					t.Format("Remove character $%02X (%s) from the party", b[0], s[0]);

				outFile << t;
				break;
			case 0x40:
				file.Read(b, 2);

				if(b[0] >= 0x00 && b[0] < 0x10)
					s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
				else if(b[0] >= 0x10 && b[0] <= 0x30)
					s[0].Format("NPC $%02X", b[0]);
				else if(b[0] >= 0x31 && b[0] <= 0x34)
					s[0].Format("Party Character %d", b[0] - 0x31);
				else
					s[0] = "<Invalid Character>";

				t.Format("Assign properties $%02X to character $%02X (%s)", b[1], b[0], s[0]);
				outFile << t;
				break;
			case 0x41:
				file.Read(b, 1);
				t.Format("Show object $%02X", b[0]);
				outFile << t;
				break;
			case 0x42:
				file.Read(b, 1);
				t.Format("Hide object $%02X", b[0]);
				outFile << t;
				break;
			case 0x43:
				file.Read(b, 2);

				if(b[0] >= 0x00 && b[0] < 0x10)
					s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
				else if(b[0] >= 0x10 && b[0] <= 0x30)
					s[0].Format("NPC $%02X", b[0]);
				else if(b[0] >= 0x31 && b[0] <= 0x34)
					s[0].Format("Party Character %d", b[0] - 0x31);
				else
					s[0] = "<Invalid Character>";

				t.Format("Assign palette $%02X to character $%02X (%s)", b[1], b[0], s[0]);
				outFile << t;
				break;
			case 0x44:
				file.Read(b, 2);

				if(b[0] >= 0x00 && b[0] < 0x10)
					s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
				else if(b[0] >= 0x10 && b[0] <= 0x30)
					s[0].Format("NPC $%02X", b[0]);
				else if(b[0] >= 0x31 && b[0] <= 0x34)
					s[0].Format("Party Character %d", b[0] - 0x31);
				else
					s[0] = "<Invalid Character>";

				if((b[1] & 0x7F) == 0x00)
					s[1] = "No vehicle";
				else if((b[1] & 0x7F) == 0x20)
					s[1] = "Chocobo";
				else if((b[1] & 0x7F) == 0x40)
					s[1] = "Magitek Armor";
				else if((b[1] & 0x7F) == 0x60)
					s[1] = "Raft";

				if(b[1] & 0x80)
					s[2] = " (Character is shown)";
				else
					s[2] = " (Character is not shown)";

				t.Format("Place character $%02X (%s) on vehicle $%02X (%s)%s", b[0], s[0], b[1] & 0x7F, s[1], s[2]);
				outFile << t;
				break;
			case 0x45:
				outFile << "Refresh objects";
				break;
			case 0x46:
				file.Read(b, 1);
				t.Format("Make party %d the current party", b[0]);
				outFile << t;
				break;
			case 0x47:
				outFile << "Command $47";
				break;
			case 0x48:
				file.Read(w, 2);
				if(w[0] & 0x4000) s[0] = " (Show text only)";
				if(w[0] & 0x8000) s[1] = " (At bottom of screen)";
				t.Format("Display dialogue message $%04X, continue executing commands%s%s", w[0] & 0x3FFF, s[0], s[1]);
				outFile << t << endl;
				
				if((w[0] & 0x3FFF) < dialogue.GetSize())
				{
					dialogue[w[0] & 0x3FFF]->ConvertToASCII(t, DI_ConvertMode, DICM_List, TAG_END, 0);
					outFile << "               " << t;

					int nChoicePtr = 0;
					nChoices = 0;
					nChoicePtr = t.Find("^");
					while(nChoicePtr != -1)
					{
						nChoices++;
						nChoicePtr = t.Find("^", nChoicePtr + 1);
					}
				}
				else
				{
					outFile << "               <Invalid Dialogue>";
					nChoices = 0;
				}

				break;
			case 0x49:
				outFile << "If dialogue window is up, wait for keypress then dismiss";
				break;
			case 0x4A:
				outFile << "Command $4A";
				break;
			case 0x4B:
				file.Read(w, 2);
				if(w[0] & 0x4000) s[0] = " (Show text only)";
				if(w[0] & 0x8000) s[1] = " (At bottom of screen)";
				t.Format("Display dialogue message $%04X, wait for button press%s%s", w[0] & 0x3FFF, s[0], s[1]);
				outFile << t << endl;

				if((w[0] & 0x3FFF) < dialogue.GetSize())
				{
					dialogue[w[0] & 0x3FFF]->ConvertToASCII(t, DI_ConvertMode, DICM_List, TAG_END, 0);
					outFile << "               " << t;

					// Get number of choices.
					int nChoicePtr = 0;
					nChoices = 0;
					nChoicePtr = t.Find("^");
					while(nChoicePtr != -1)
					{
						nChoices++;
						nChoicePtr = t.Find("^", nChoicePtr + 1);
					}
				}
				else
				{
					outFile << "               <Invalid Dialogue>";
					nChoices = 0;
				}

				break;
			case 0x4C:
				file.Read(b, 2);
				t.Format("Command $4C, $%02X, $%02X", b[0], b[1]);
				outFile << t;
				break;
			case 0x4D:
				file.Read(b, 2);
				t.Format("Invoke battle, enemy set $%02X, background $%02X", b[0], b[1]);
				outFile << t;
				break;
			case 0x4E:
				outFile << "Command $4E";
				break;
			case 0x4F:
				outFile << "Exit the current location";
				break;
			case 0x50:
				file.Read(b, 1);
				t.Format("Tint screen (cumulative) with color $%02X", b[0]);
				outFile << t;
				break;
			case 0x51:
				file.Read(b, 3);
				t.Format("Command $51, %02X, %02X, %02X", b[0], b[1], b[2]);
				outFile << t;
				break;
			case 0x52:
				file.Read(b, 1);
				t.Format("Tint characters (cumulative) with color $%02X", b[0]);
				outFile << t;
				break;
			case 0x53:
				file.Read(b, 3);
				t.Format("Command $53, %02X, %02X, %02X", b[0], b[1], b[2]);
				outFile << t;
				break;
			case 0x54:
				outFile << "Command $54";
				break;
			case 0x55:
				file.Read(b, 1);

				x = (b[0] & 0xF0) >> 4;
				y = (b[0] & 0x0F);

				s[0] = g_strColorComponents[x];

				t.Format("Flash screen with color component(s) %d (%s), at intensity %d", x, s[0], y);
				outFile << t;
				break;
			case 0x56:
				file.Read(b, 1);

				x = (b[0] & 0xF0) >> 4;
				y = (b[0] & 0x0F);

				s[0] = g_strColorComponents[x];

				t.Format("Increase color component(s) %d (%s), at intensity %d", b[0]);
				outFile << t;
				break;
			case 0x57:
				file.Read(b, 1);

				x = (b[0] & 0xF0) >> 4;
				y = (b[0] & 0x0F);

				s[0] = g_strColorComponents[x];

				t.Format("Decrease color component(s) %d (%s), at intensity %d", b[0]);
				outFile << t;
				break;
			case 0x58:
				file.Read(b, 1);
				t.Format("Shake screen ($%02X)", b[0]);
				outFile << t;
				break;
			case 0x59:
				file.Read(b, 1);
				t.Format("Unfade screen at speed $%02X", b[0]);
				outFile << t;
				break;
			case 0x5A:
				file.Read(b, 1);
				t.Format("Fade screen at speed $%02X", b[0]);
				outFile << t;
				break;
			case 0x5B:
				outFile << "Command $5B";
				break;
			case 0x5C:
				outFile << "Command $5C";
				break;
			case 0x5D:
				file.Read(b, 2);
				t.Format("Scroll BG0, speed %d x %d", b[0], b[1]);
				outFile << t;
				break;
			case 0x5E:
				file.Read(b, 2);
				t.Format("Scroll BG1, speed %d x %d", b[0], b[1]);
				outFile << t;
				break;
			case 0x5F:
				file.Read(b, 2);
				t.Format("Scroll BG2, speed %d x %d", b[0], b[1]);
				outFile << t;
				break;
			case 0x60:
				file.Read(b, 2);
				t.Format("Command $60, $%02X, $%02X", b[0], b[1]);
				outFile << t;
				break;
			case 0x61:
				file.Read(b, 3);
				t.Format("Command $61, $%02X, $%02X, $%02X", b[0], b[1], b[2]);
				outFile << t;
				break;
			case 0x62:
				file.Read(b, 1);
				t.Format("Mosaic screen, speed %d", b[0]);
				outFile << t;
				break;
			case 0x63:
				file.Read(b, 1);
				t.Format("Command $63, $%02X", b[0]);
				outFile << t;
				break;
			case 0x64:
				file.Read(b, 2);
				t.Format("Command $64, $%02X, $%02X", b[0], b[1]);
				outFile << t;
				break;
			case 0x65:
				file.Read(b, 2);
				t.Format("Command $65, $%02X, $%02X", b[0], b[1]);
				outFile << t;
				break;
			case 0x6A:
				file.Read(w, 2);
				file.Read(b, 3);
				t.Format("Load map $%04X (%d, %d), flags $%02X", w[0], b[0], b[1], b[2]);
				outFile << t;
				break;
			case 0x6B:
				file.Read(w, 2);
				file.Read(b, 3);
				t.Format("Load map $%04X (%d, %d), flags $%02X", w[0], b[0], b[1], b[2]);
				outFile << t;
				break;
			case 0x6C:
				file.Read(w, 6);
				t.Format("Command $6C, $%04X, $%04X, $%04X", w[0], w[1], w[2]);
				outFile << t;
				break;
			case 0x70:
				file.Read(b, 2);
				t.Format("Scroll BG0 (%d, %d)", b[0], b[1]);
				outFile << t;
				break;
			case 0x71:
				file.Read(b, 2);
				t.Format("Scroll BG1 (%d, %d)", b[0], b[1]);
				outFile << t;
				break;
			case 0x72:
				file.Read(b, 2);
				t.Format("Scroll BG2 (%d, %d)", b[0], b[1]);
				outFile << t;
				break;
			case 0x73:
				file.Read(b, 4);
				t.Format("Replace current map's BG0 at (%d, %d) with the following (%d x %d) chunk, refresh immediately", b[0], b[1], b[3], b[2]);
				outFile << t;

				for(y = 0; y < b[2]; y++)
				{
					outFile << endl;

					dwOffset = file.GetPosition();
					pc = dwOffset + 0xC00000 - 0x200;

					t.Format("%02X/%04X:       dc.b ", (pc & 0xFF0000) >> 16, pc & 0xFFFF);
					outFile << t;

					file.Read(&b[15], 1);
					t.Format("$%02X", b[15]);
					outFile << t;

					for(x = 0; x < b[3] - 1; x++)
					{
						t.Format(", $%02X", b[15]);
						outFile << t;
						file.Read(&b[15], 1);
					}
				}
				break;
			case 0x74:
				file.Read(b, 4);
				t.Format("Replace current map's BG0 at (%d, %d) with the following (%d x %d) chunk", b[0], b[1], b[3], b[2]);
				outFile << t;

				for(y = 0; y < b[2]; y++)
				{
					outFile << endl;

					dwOffset = file.GetPosition();
					pc = dwOffset + 0xC00000 - 0x200;

					t.Format("%02X/%04X:       dc.b ", (pc & 0xFF0000) >> 16, pc & 0xFFFF);
					outFile << t;

					file.Read(&b[15], 1);
					t.Format("$%02X", b[15]);
					outFile << t;

					for(x = 0; x < b[3] - 1; x++)
					{
						t.Format(", $%02X", b[15]);
						outFile << t;
						file.Read(&b[15], 1);
					}
				}
				break;
			case 0x75:
				outFile << "Refresh map after alteration";
				break;
			case 0x77:
				file.Read(b, 1);
				t.Format("Command $77, $%02X", b[0]);
				outFile << t;
				break;
			case 0x78:
				file.Read(b, 1);
				t.Format("Command $78, $%02X", b[0]);
				outFile << t;
				break;
			case 0x79:
				file.Read(b, 3);
				t.Format("Command $79, $%02X, $%02X, $%02X", b[0], b[1], b[2]);
				outFile << t;
				break;
			case 0x7A:
				file.Read(b, 4);
				t.Format("Command $7A, $%02X, $%02X, $%02X, $%02X", b[0], b[1], b[2], b[3]);
				outFile << t;
				break;
			case 0x7B:
				outFile << "Command $7B";
				break;
			case 0x7C:
				file.Read(b, 1);
				t.Format("Command $7C, $%02X", b[0]);
				outFile << t;
				break;
			case 0x7D:
				file.Read(b, 1);
				t.Format("Command $7D, $%02X", b[0]);
				outFile << t;
				break;
			case 0x7E:
				file.Read(b, 2);
				t.Format("Move characters to (%d, %d)", b[0], b[1]);
				outFile << t;
				break;
			case 0x7F:
				file.Read(b, 2);
				s[0] = FixedTextToCString(characters[b[1]].name, 6, TAG_END, 0);
				t.Format("Change character $%02X's name to $%02X (%s)", b[0], b[1], s[0]);
				outFile << t;
				break;
			case 0x80:
				file.Read(b, 1);
				t.Format("Add item $%02X (%s) to inventory", b[0], FixedTextToCString(items[b[0]].name, 13, TAG_END, 0));
				outFile << t;
				break;
			case 0x81:
				file.Read(b, 1);
				t.Format("Remove item $%02X (%s) from inventory", b[0], FixedTextToCString(items[b[0]].name, 13, TAG_END, 0));
				outFile << t;
				break;
			case 0x82:
				outFile << "Command $82";
				break;
			case 0x84:
				file.Read(w, 2);
				t.Format("Give %d GP to party", w[0]);
				outFile << t;
				break;
			case 0x85:
				file.Read(w, 2);
				t.Format("Take %d GP from party", w[0]);
				outFile << t;
				break;
			case 0x86:
				file.Read(b, 1);
				
				if(b[0] > 0x35 && b[0] < 0x51)
					s[0] = FixedTextToCString(espers[b[0] - 0x36].name, 8, TAG_END, 0);
				else
					s[0] = "<Invalid Esper>";

				t.Format("Give esper $%02X (%s) to party", b[0], s[0]);
				outFile << t;
				break;
			case 0x87:
				file.Read(b, 1);
				
				if(b[0] > 0x35 && b[0] < 0x51)
					s[0] = FixedTextToCString(espers[b[0] - 0x36].name, 8, TAG_END, 0);
				else
					s[0] = "<Invalid Esper>";

				t.Format("Take esper $%02X (%s) from party", b[0], s[0]);
				outFile << t;
				break;
			case 0x88:
				file.Read(b, 3);

				if(b[0] >= 0x00 && b[0] < 0x10)
					s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
				else if(b[0] >= 0x10 && b[0] <= 0x30)
					s[0].Format("NPC $%02X", b[0]);
				else if(b[0] >= 0x31 && b[0] <= 0x34)
					s[0].Format("Party Character %d", b[0] - 0x31);
				else
					s[0] = "<Invalid Character>";

				t.Format("Remove the following status ailments from character $%02X (%s): $%02X, $%02X", b[0], s[0], b[1], b[2]);
				outFile << t;
				break;
			case 0x89:
				file.Read(b, 3);

				if(b[0] >= 0x00 && b[0] < 0x10)
					s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
				else if(b[0] >= 0x10 && b[0] <= 0x30)
					s[0].Format("NPC $%02X", b[0]);
				else if(b[0] >= 0x31 && b[0] <= 0x34)
					s[0].Format("Party Character %d", b[0] - 0x31);
				else
					s[0] = "<Invalid Character>";

				t.Format("Inflict the following status ailments on character $%02X (%s): $%02X, $%02X", b[0], s[0], b[1], b[2]);
				outFile << t;
				break;
			case 0x8A:
				file.Read(b, 3);

				if(b[0] >= 0x00 && b[0] < 0x10)
					s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
				else if(b[0] >= 0x10 && b[0] <= 0x30)
					s[0].Format("NPC $%02X", b[0]);
				else if(b[0] >= 0x31 && b[0] <= 0x34)
					s[0].Format("Party Character %d", b[0] - 0x31);
				else
					s[0] = "<Invalid Character>";

				t.Format("Toggle the following status ailments for character $%02X (%s): $%02X, $%02X", b[0], s[0], b[1], b[2]);
				outFile << t;
				break;
			case 0x8B:
				file.Read(b, 2);
				t.Format("Command $8B, $%02X, $%02X", b[0], b[1]);
				outFile << t;
				break;
			case 0x8C:
				file.Read(b, 2);
				t.Format("Command $8C, $%02X, $%02X", b[0], b[1]);
				outFile << t;
				break;
			case 0x8D:
				file.Read(b, 1);

				if(b[0] >= 0x00 && b[0] < 0x10)
					s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
				else if(b[0] >= 0x10 && b[0] <= 0x30)
					s[0].Format("NPC $%02X", b[0]);
				else if(b[0] >= 0x31 && b[0] <= 0x34)
					s[0].Format("Party Character %d", b[0] - 0x31);
				else
					s[0] = "<Invalid Character>";

				t.Format("Remove all equipment from character $%02X (%s)", b[0], s[0]);
				outFile << t;
				break;
			case 0x8E:
				outFile << "Command $8E";
				break;
			case 0x8F:
				outFile << "Command $8F";
				break;
			case 0x90:
				outFile << "Command $90";
				break;
			case 0x91:
				outFile << "Pause for 15 units";
				break;
			case 0x92:
				outFile << "Pause for 30 units";
				break;
			case 0x93:
				outFile << "Pause for 45 units";
				break;
			case 0x94:
				outFile << "Pause for 60 units";
				break;
			case 0x95:
				outFile << "Pause for 120 units";
				break;
			case 0x96:
				outFile << "Restore screen from fade";
				break;
			case 0x97:
				outFile << "Fade screen to black";
				break;
			case 0x98:
				file.Read(b, 1);

				if(b[0] >= 0x00 && b[0] < 0x10)
					s[0] = FixedTextToCString(characters[b[0]].name, 6, TAG_END, 0);
				else if(b[0] >= 0x10 && b[0] <= 0x30)
					s[0].Format("NPC $%02X", b[0]);
				else if(b[0] >= 0x31 && b[0] <= 0x34)
					s[0].Format("Party Character %d", b[0] - 0x31);
				else
					s[0] = "<Invalid Character>";

				t.Format("Invoke name change screen for character $%02X (%s)", b[0], s[0]);
				outFile << t;
				break;
			case 0x99:
				file.Read(b, 3);
				t.Format("Invoke party selection screen (%d groups) ($%02X, $%02X)", b[0], b[1], b[2]);
				outFile << t;
				break;
			case 0x9A:
				outFile << "Invoke Coliseum item selection screen";
				break;
			case 0x9B:
				file.Read(b, 1);
				t.Format("Invoke shop $%02X", b[0]);
				outFile << t;
				break;
			case 0x9C:
				file.Read(b, 1);
				t.Format("Command $9C, $%02X", b[0]);
				outFile << t;
				break;
			case 0x9D:
				outFile << "Invoke party fighting order screen (from final battle)";
				break;
			case 0xA0:
				file.Read(b, 5);
				t.Format("Command $A0, $%02X, $%02X, $%02X, $%02X, $%02X", b[0], b[1], b[2], b[3], b[4]);
				outFile << t;
				break;
			case 0xA1:
				file.Read(b, 1);
				t.Format("Command $A1, $%02X", b[0]);
				outFile << t;
				break;
			case 0xA2:
				outFile << "Command $A2";
				break;
			case 0xA6:
				outFile << "Command $A6";
				break;
			case 0xA7:
				file.Read(b, 1);
				t.Format("Command $A7, $%02X", b[0]);
				outFile << t;
				break;
			case 0xA8:
				outFile << "Show floating island soaring into the sky";
				break;
			case 0xA9:
				outFile << "Show title screen";
				break;
			case 0xAA:
				outFile << "Show intro with Magitek Armor walking through snowfields";
				break;
			case 0xAB:
				outFile << "Invoke game loading screen";
				break;
			case 0xAC:
				outFile << "Command $AC";
				break;
			case 0xAD:
				outFile << "Show world getting torn apart";
				break;
			case 0xAE:
				outFile << "Show train car ride out of Magitek Factory";
				break;
			case 0xAF:
				outFile << "Invoke random Coliseum battle";
				break;
			case 0xB0:
				file.Read(b, 1);
				t.Format("Execute the following commands until $B1 %d times", b[0]);
				outFile << t;
				break;
			case 0xB1:
				outFile << "End block of repeating commands";
				break;
			case 0xB2:
				file.Read(d, 3);
				t.Format("Jump to subroutine $%06X", d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xB3:
				file.Read(b, 1);
				file.Read(d, 3);
				t.Format("Command $B3 ($%02X, $%06X)", b[0], d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xB4:
				file.Read(b, 1);
				t.Format("Pause for %d units", b[0]);
				outFile << t;
				break;
			case 0xB5:
				file.Read(b, 1);
				t.Format("Pause for 15 * %d (%d) units", b[0], b[0] * 15);
				outFile << t;
				break;
			case 0xB6:
				file.Read(d, 3);
				t.Format("Indexed branch based on prior dialogue selection [");

				//while((b[15] < 8) && ((d[0] & 0xFF) != 0xFE))
				for(b[15] = 0; b[15] < nChoices; b[15]++)
				{
					s[0].Format("$%06X, ", d[0] + 0xCA0000);
					t += s[0];

					d[0] = 0;
					file.Read(d, 3);
				}

				file.Seek(-3, CFile::current);

				t = t.Left(t.GetLength() - 2);  t += "]";
				outFile << t;
				break;
			case 0xB7:
				file.Read(b, 1);
				file.Read(d, 3);
				t.Format("If bit $1DC9($%02X) [$%04X, bit %d] is clear, branch to $%06X", b[0], 0x1DC9 + b[0] / 8, b[0] & 7, d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xB8:
				file.Read(b, 1);
				t.Format("Set bit $1DC9($%02X) [$%04X, bit %d]", b[0], 0x1DC9 + b[0] / 8, b[0] & 7);
				outFile << t;
				break;
			case 0xB9:
				file.Read(b, 1);
				t.Format("Clear bit $1DC9($%02X) [$%04X, bit %d]", b[0], 0x1DC9 + b[0] / 8, b[0] & 7);
				outFile << t;
				break;
			case 0xBA:
				file.Read(b, 1);
				t.Format("Command $BA, $%02X", b[0]);
				outFile << t;
				break;
			case 0xBB:
				outFile << "Command $BB";
				break;
			case 0xBC:
				file.Read(b, 2);
				t.Format("If bit $1E80($%02X) [$%04X, bit %d] is clear, return ($%02X)", b[0], 0x1E80 + b[0] / 8, b[0] & 7, b[1]);
				outFile << t;
				break;
			case 0xBD:
				file.Read(d, 3);
				t.Format("Increment $1F6D and branch to $%06X if $C0FD00 + ($1F6D) >= $80", d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xBE:
				file.Read(b, 1);
				t.Empty();

				for(b[15] = 0; b[15] < (b[0] & 0x7F); b[15]++)
				{
					d[0] = 0;
					file.Read(&d[0], 3);
					
					if((d[0] & 0xF00000) == 0x000000)
						s[0].Format("If standing below the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0x100000)
						s[0].Format("If standing left of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0x200000)
						s[0].Format("If standing above the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0x300000)
						s[0].Format("If standing right of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0x400000)
						s[0].Format("If standing 0x40 of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0x500000)
						s[0].Format("If standing 0x50 of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0x600000)
						s[0].Format("If standing 0x60 of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0x700000)
						s[0].Format("If standing 0x70 of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0x800000)
						s[0].Format("If standing 0x80 of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0x900000)
						s[0].Format("If standing 0x90 of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0xA00000)
						s[0].Format("If standing 0xA0 of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0xB00000)
						s[0].Format("If standing 0xB0 of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0xC00000)
						s[0].Format("If standing 0xC0 of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0xD00000)
						s[0].Format("If standing 0xD0 of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0xE00000)
						s[0].Format("If standing 0xE0 of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);
					else if((d[0] & 0xF00000) == 0xF00000)
						s[0].Format("If standing 0xF0 of the trigger, jump to subroutine $%06X; ", (d[0] & 0x0FFFFF) + 0xCA0000);

					if(bFirst != TRUE)
						t += "\n               ";

					bFirst = FALSE;

					t += s[0];
				}

				t = t.Left(t.GetLength() - 2);
				outFile << t;
				if(b[0] & 0x80) outFile << " (0x80 is set)";
				break;
			case 0xBF:
				outFile << "Show airship scene from ending" << endl;
				break;

			// Conditionality commands != fun
			case 0xC0:
				file.Read(w, 2);
				file.Read(d, 3);

				if(w[0] & 0x8000) s[0] = "is clear"; else s[0] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xC1:
				file.Read(w, 4);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 2; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xC2:
				file.Read(w, 6);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 3; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xC3:
				file.Read(w, 8);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 4; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
					w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xC4:
				file.Read(w, 10);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 5; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
					w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
					w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xC5:
				file.Read(w, 12);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 6; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
					w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
					w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
					w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xC6:
				file.Read(w, 14);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 7; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
					w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
					w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
					w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
					w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xC7:
				file.Read(w, 16);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 8; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s) or "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
					w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
					w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
					w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
					w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
					w[7] & 0x7FFF, (w[7] & 0x7FFF) / 8 + 0x1E80, w[7] & 7, s[7],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xC8:
				file.Read(w, 2);
				file.Read(d, 3);

				if(w[0] & 0x8000) s[0] = "is clear"; else s[0] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xC9:
				file.Read(w, 4);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 2; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xCA:
				file.Read(w, 6);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 3; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xCB:
				file.Read(w, 8);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 4; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
					w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xCC:
				file.Read(w, 10);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 5; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
					w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
					w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xCD:
				file.Read(w, 12);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 6; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
					w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
					w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
					w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xCE:
				file.Read(w, 14);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 7; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
					w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
					w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
					w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
					w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xCF:
				file.Read(w, 16);
				file.Read(d, 3);

				for(b[15] = 0; b[15] < 8; b[15]++)
					if(w[b[15]] & 0x8000) s[b[15]] = "is clear"; else s[b[15]] = "is set";

				t.Format("If ($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s) and "
					"($1E80($%03X) [$%04X, bit %d] %s), branch to $%06X",
					w[0] & 0x7FFF, (w[0] & 0x7FFF) / 8 + 0x1E80, w[0] & 7, s[0],
					w[1] & 0x7FFF, (w[1] & 0x7FFF) / 8 + 0x1E80, w[1] & 7, s[1],
					w[2] & 0x7FFF, (w[2] & 0x7FFF) / 8 + 0x1E80, w[2] & 7, s[2],
					w[3] & 0x7FFF, (w[3] & 0x7FFF) / 8 + 0x1E80, w[3] & 7, s[3],
					w[4] & 0x7FFF, (w[4] & 0x7FFF) / 8 + 0x1E80, w[4] & 7, s[4],
					w[5] & 0x7FFF, (w[5] & 0x7FFF) / 8 + 0x1E80, w[5] & 7, s[5],
					w[6] & 0x7FFF, (w[6] & 0x7FFF) / 8 + 0x1E80, w[6] & 7, s[6],
					w[7] & 0x7FFF, (w[7] & 0x7FFF) / 8 + 0x1E80, w[7] & 7, s[7],
					d[0] + 0xCA0000);
				outFile << t;
				break;
			case 0xD0:
				file.Read(b, 1);
				t.Format("Set event bit $1E80($0%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
				outFile << t;
				break;
			case 0xD1:
				file.Read(b, 1);
				t.Format("Clear event bit $1E80($0%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
				outFile << t;
				break;
			case 0xD2:
				file.Read(b, 1);
				t.Format("Set event bit $1E80($1%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
				outFile << t;
				break;
			case 0xD3:
				file.Read(b, 1);
				t.Format("Clear event bit $1E80($1%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
				outFile << t;
				break;
			case 0xD4:
				file.Read(b, 1);
				t.Format("Set event bit $1E80($2%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
				outFile << t;
				break;
			case 0xD5:
				file.Read(b, 1);
				t.Format("Clear event bit $1E80($2%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
				outFile << t;
				break;
			case 0xD6:
				file.Read(b, 1);
				t.Format("Set event bit $1E80($3%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EE0, b[0] & 7);
				outFile << t;
				break;
			case 0xD7:
				file.Read(b, 1);
				t.Format("Clear event bit $1E80($3%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EE0, b[0] & 7);
				outFile << t;
				break;
			case 0xD8:
				file.Read(b, 1);
				t.Format("Set event bit $1E80($4%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1F00, b[0] & 7);
				outFile << t;
				break;
			case 0xD9:
				file.Read(b, 1);
				t.Format("Clear event bit $1E80($4%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1F00, b[0] & 7);
				outFile << t;
				break;
			case 0xDA:
				file.Read(b, 1);
				t.Format("Set event bit $1E80($5%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1F20, b[0] & 7);
				outFile << t;
				break;
			case 0xDB:
				file.Read(b, 1);
				t.Format("Clear event bit $1E80($5%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1F20, b[0] & 7);
				outFile << t;
				break;
			case 0xDC:
				file.Read(b, 1);
				t.Format("Set event bit $1E80($6%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1F40, b[0] & 7);
				outFile << t;
				break;
			case 0xDD:
				file.Read(b, 1);
				t.Format("Clear event bit $1E80($6%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1F40, b[0] & 7);
				outFile << t;
				break;
			case 0xDE:
				outFile << "Command $DE";
				break;
			case 0xDF:
				outFile << "Command $DF";
				break;
			case 0xE0:
				outFile << "Command $E0";
				break;
			case 0xE1:
				outFile << "Command $E1";
				break;
			case 0xE2:
				outFile << "Command $E2";
				break;
			case 0xE3:
				outFile << "Command $E3";
				break;
			case 0xE4:
				outFile << "Command $E4";
				break;
			case 0xE7:
				outFile << "Command $E7";
				break;
			case 0xE8:
				file.Read(b, 1);
				file.Read(w, 2);
				t.Format("Set word $1FC2($%02X) [$%04X] to $%04X", b[0], 0x1FC2 + b[0] * 2, w[0]);
				outFile << t;
				break;
			case 0xE9:
				file.Read(b, 1);
				file.Read(w, 2);
				t.Format("Command $E9, $%02X, $%04X", b[0], w[0]);
				outFile << t;
				break;
			case 0xEA:
				file.Read(b, 1);
				file.Read(w, 2);
				t.Format("Command $EA, $%02X, $%04X", b[0], w[0]);
				outFile << t;
				break;
			case 0xEB:
				file.Read(b, 1);
				file.Read(w, 2);
				t.Format("Command $EB, $%02X, $%04X", b[0], w[0]);
				outFile << t;
				break;
			case 0xEF:
				file.Read(b, 2);
				t.Format("Command $EF, $%02X, $%02X", b[0], b[1]);
				outFile << t;
				break;
			case 0xF0:
				file.Read(b, 1);
				t.Format("Play song %d", b[0]);
				outFile << t;
				break;
			case 0xF1:
				file.Read(b, 2);
				t.Format("Fade in song %d with speed %d", b[0], b[1]);
				outFile << t;
				break;
			case 0xF2:
				file.Read(b, 1);
				t.Format("Fade out current song with speed %d", b[0]);
				outFile << t;
				break;
			case 0xF3:
				file.Read(b, 1);
				t.Format("Command $F3, $%02X", b[0]);
				outFile << t;
				break;
			case 0xF4:
				file.Read(b, 1);
				t.Format("Play sound effect %d", b[0]);
				outFile << t;
				break;
			case 0xF5:
				file.Read(b, 3);
				t.Format("Command $F5, $%02X, $%02X, $%02X", b[0], b[1], b[2]);
				outFile << t;
				break;
			case 0xF6:
				file.Read(b, 3);
				t.Format("Command $F6, $%02X, $%02X, $%02X", b[0], b[1], b[2]);
				outFile << t;
				break;
			case 0xF7:
				outFile << "Command $F7";
				break;
			case 0xF8:
				outFile << "Command $F8";
				break;
			case 0xF9:
				file.Read(b, 1);
				t.Format("Command $F9, $%02X", b[0]);
				outFile << t;
				break;
			case 0xFA:
				outFile << "Command $FA";
				break;
			case 0xFE:
				outFile << "Return" << endl;
				break;

			default:
				if(opcode >= 0x00 && opcode <= 0x34)
				{
					file.Read(b, 1);

					if(opcode >= 0x00 && opcode < 0x10)
						s[0] = FixedTextToCString(characters[opcode].name, 6, TAG_END, 0);
					else if(opcode >= 0x10 && opcode <= 0x30)
						s[0].Format("NPC $%02X", opcode);
					else if(opcode >= 0x31 && opcode <= 0x34)
						s[0].Format("Party Character %d", opcode - 0x31);
					else
						s[0] = "<Invalid Character>";

					if(b[0] & 0x80) s[1] = "(Wait until complete)"; else s[1].Empty();
					t.Format("Begin action queue for character $%02X (%s), %d bytes long %s", opcode, s[0], b[0] & 0x7F, s[1]);
					outFile << t << endl;

					opcode = 0;

					dwQueueStart = file.GetPosition();
					bQueueLen = b[0] & 0x7F;

					while(file.GetPosition() < dwQueueStart + bQueueLen)
					{
						for(int i = 0; i < 16; i++)
						{
							b[i] = w[i] = d[i] = 0;
							s[i].Empty();
						}

						dwOffset = file.GetPosition();
						pc = dwOffset + 0xC00000 - 0x200;

						file.Read(&opcode, 1);

						t.Format("%02X/%04X: %02X       ", (pc & 0xFF0000) >> 16, pc & 0xFFFF, opcode);
						outFile << t;

						switch(opcode)
						{
							case 0x80:
								outFile << "Move character up 1 tile";
								break;
							case 0x81:
								outFile << "Move character right 1 tile";
								break;
							case 0x82:
								outFile << "Move character down 1 tile";
								break;
							case 0x83:
								outFile << "Move character left 1 tile";
								break;

							case 0x84:
								outFile << "Move character up 2 tiles";
								break;
							case 0x85:
								outFile << "Move character right 2 tiles";
								break;
							case 0x86:
								outFile << "Move character down 2 tiles";
								break;
							case 0x87:
								outFile << "Move character left 2 tiles";
								break;

							case 0x88:
								outFile << "Move character up 3 tiles";
								break;
							case 0x89:
								outFile << "Move character right 3 tiles";
								break;
							case 0x8A:
								outFile << "Move character down 3 tiles";
								break;
							case 0x8B:
								outFile << "Move character left 3 tiles";
								break;

							case 0x8C:
								outFile << "Move character up 4 tiles";
								break;
							case 0x8D:
								outFile << "Move character right 4 tiles";
								break;
							case 0x8E:
								outFile << "Move character down 4 tiles";
								break;
							case 0x8F:
								outFile << "Move character left 4 tiles";
								break;

							case 0x90:
								outFile << "Move character up 5 tiles";
								break;
							case 0x91:
								outFile << "Move character right 5 tiles";
								break;
							case 0x92:
								outFile << "Move character down 5 tiles";
								break;
							case 0x93:
								outFile << "Move character left 5 tiles";
								break;

							case 0x94:
								outFile << "Move character up 6 tiles";
								break;
							case 0x95:
								outFile << "Move character right 6 tiles";
								break;
							case 0x96:
								outFile << "Move character down 6 tiles";
								break;
							case 0x97:
								outFile << "Move character left 6 tiles";
								break;

							case 0x98:
								outFile << "Move character up 7 tiles";
								break;
							case 0x99:
								outFile << "Move character right 7 tiles";
								break;
							case 0x9A:
								outFile << "Move character down 7 tiles";
								break;
							case 0x9B:
								outFile << "Move character left 7 tiles";
								break;

							case 0x9C:
								outFile << "Move character up 8 tiles";
								break;
							case 0x9D:
								outFile << "Move character right 8 tiles";
								break;
							case 0x9E:
								outFile << "Move character down 8 tiles";
								break;
							case 0x9F:
								outFile << "Move character left 8 tiles";
								break;

							case 0xA0:
								outFile << "Move character right/up 1x1 tiles";
								break;
							case 0xA1:
								outFile << "Move character right/down 1x1 tiles";
								break;
							case 0xA2:
								outFile << "Move character left/down 1x1 tiles";
								break;
							case 0xA3:
								outFile << "Move character left/up 1x1 tiles";
								break;
							case 0xA4:
								outFile << "Move character right/up 1x2 tiles";
								break;
							case 0xA5:
								outFile << "Move character right/up 2x1 tiles";
								break;
							case 0xA6:
								outFile << "Move character right/down 2x1 tiles";
								break;
							case 0xA7:
								outFile << "Move character right/down 1x2 tiles";
								break;
							case 0xA8:
								outFile << "Move character left/down 1x2 tiles";
								break;
							case 0xA9:
								outFile << "Move character left/down 2x1 tiles";
								break;
							case 0xAA:
								outFile << "Move character left/up 2x1 tiles";
								break;
							case 0xAB:
								outFile << "Move character left/up 1x2 tiles";
								break;
							
							case 0xC0:
								outFile << "Set character's event speed to slowest";
								break;
							case 0xC1:
								outFile << "Set character's event speed to slow";
								break;
							case 0xC2:
								outFile << "Set character's event speed to normal";
								break;
							case 0xC3:
								outFile << "Set character's event speed to fast";
								break;
							case 0xC4:
								outFile << "Set character's event speed to fastest";
								break;

							case 0xC6:
								outFile << "Set character to walk when moving";
								break;
							case 0xC7:
								outFile << "Set character to stay still when moving";
								break;

							case 0xC8:
								file.Read(b, 1);
								t.Format("Queue command $C8, $%02X", b[0]);
								outFile << t;
								break;
							case 0xC9:
								file.Read(b, 1);
								t.Format("Queue command $C9, $%02X", b[0]);
								outFile << t;
								break;

							case 0xCC:
								outFile << "Turn character up";
								break;
							case 0xCD:
								outFile << "Turn character right";
								break;
							case 0xCE:
								outFile << "Turn character down";
								break;
							case 0xCF:
								outFile << "Turn character left";
								break;

							case 0xD0:
								outFile << "Queue command $D0";
								break;
							case 0xD1:
								outFile << "Make character disappear";
								break;

							case 0xD5:
								file.Read(b, 2);
								t.Format("Set character position to (%d, %d)", b[0], b[1]);
								outFile << t;
								break;

							case 0xD7:
								outFile << "Queue command $D7";
								break;

							case 0xDC:
								outFile << "Make character jump (low)";
								break;
							case 0xDD:
								outFile << "Make character jump (high)";
								break;

							case 0xE0:
								file.Read(b, 1);
								t.Format("Pause for %d units", b[0]);
								outFile << t;
								break;

							case 0xE1:
								file.Read(b, 1);
								t.Format("Set event bit $1E80($0%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
								outFile << t;
								break;

							case 0xE2:
								file.Read(b, 1);
								t.Format("Set event bit $1E80($1%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
								outFile << t;
								break;

							case 0xE3:
								file.Read(b, 1);
								t.Format("Set event bit $1E80($2%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
								outFile << t;
								break;

							case 0xE4:
								file.Read(b, 1);
								t.Format("Clear event bit $1E80($0%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1E80, b[0] & 7);
								outFile << t;
								break;

							case 0xE5:
								file.Read(b, 1);
								t.Format("Clear event bit $1E80($1%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EA0, b[0] & 7);
								outFile << t;
								break;

							case 0xE6:
								file.Read(b, 1);
								t.Format("Clear event bit $1E80($2%02X) [$%04X, bit %d]", b[0], b[0] / 8 + 0x1EC0, b[0] & 7);
								outFile << t;
								break;

							case 0xF9:
								file.Read(d, 3);
								t.Format("Branch to $%06X", d[0] + 0xCA0000);
								outFile << t;
								break;

							case 0xFA:
								file.Read(b, 1);
								t.Format("Increment $1F6D and branch %d bytes backwards ($%06X) if ($C0FD00 + ($1F6D)) >= $80", b[0], pc - b[0]);
								outFile << t;
								break;
							case 0xFB:
								file.Read(b, 1);
								t.Format("Increment $1F6D and branch %d bytes forwards ($%06X) if ($C0FD00 + ($1F6D)) >= $80", b[0], pc + b[0]);
								outFile << t;
								break;
							case 0xFC:
								file.Read(b, 1);
								t.Format("Branch %d bytes backwards ($%06X)", b[0], pc - b[0]);
								outFile << t;
								break;
							case 0xFD:
								file.Read(b, 1);
								t.Format("Branch %d bytes forwards ($%06X)", b[0], pc + b[0]);
								outFile << t;
								break;

							case 0xFF:
								outFile << "End queue";
								break;

							default:
								if(opcode >= 0x00 && opcode <= 0x3F)
								{
									t.Format("Character Graphical Action $%02X", opcode);
									outFile << t;
								}
								else if(opcode >= 0x40 && opcode <= 0x7F)
								{
									t.Format("Character Graphical Action $%02X, flipped horizontally", opcode & 0x3F);
									outFile << t;
								}
						}

						outFile << endl;
					}
				}
				break;
		}

		if(!dwQueueStart) outFile << endl;
	}

	outFile.close();
	file.Close();
}

void readDialogue(CFile* m_pFile)
{
	WORD wPageBound = 0;
	m_pFile->Seek(0xCE800, CFile::begin);
	m_pFile->Read(&wPageBound, 2);

	BYTE bTemp[1024];

	for(DWORD i = 0xCE802; i < 0xD01FE; i += 2)
	{
		int nPos = 0;

		DialogueItem* pDlg = new DialogueItem;
		dialogue.Add(pDlg);

		WORD wBegin = 0, wEnd = 0;
		m_pFile->Seek(i, CFile::begin);
		m_pFile->Read(&wBegin, 2);
		m_pFile->Read(&wEnd, 2);

		DWORD dwBegin = wBegin, dwEnd = wEnd;

		if((i - 0xCE802) / 2 + 1 >= wPageBound) dwEnd += 0x10000;
		if((i - 0xCE802) / 2 >= wPageBound) dwBegin += 0x10000;

		DWORD dwLength = dwEnd - dwBegin;

		if(dwLength)
		{
			BYTE bChar;
			m_pFile->Seek(dwBegin + 0xD0200, CFile::begin);
			m_pFile->Read(&bChar, 1);

			while(bChar)
			{
				bTemp[nPos++] = bChar;
				m_pFile->Read(&bChar, 1);
			}

			bTemp[nPos++] = 0x00;

			pDlg->text = new BYTE[nPos];
			pDlg->length = nPos;
			CopyMemory(pDlg->text, bTemp, nPos);
		}
		else
		{
			pDlg->text = NULL;
			pDlg->length = 0;
		}
	}

	// Read item data.
	m_pFile->Seek(0x12B500, CFile::begin);
	for(int n = 0; n < 256; n++)
		m_pFile->Read(items[n].name, 13);

	// Read esper data.
	m_pFile->Seek(0x26F8E1, CFile::begin);
	for(n = 0; n < 27; n++)
		m_pFile->Read(espers[n].name, 8);

	// Read character data.
	m_pFile->Seek(0x047AC0, CFile::begin);
	for(n = 0; n < 64; n++)
		m_pFile->Read(characters[n].name, 6);
}



CString g_dteTable[] = {
//		0,    1,    2,    3,    4,    5,    6,    7,    8,    9,    A,    B,    C,    D,    E,    F
/* 8 */ "e ", " t", ": ", "th", "t ", "he", "s ", "er", " a", "re", "in", "ou", "d ", " w", " s", "an",
/* 9 */ "o ", " h", " o", "r ", "n ", "at", "to", " i", ", ", "ve", "ng", "ha", " m", "Th", "st", "on",
/* A */ "yo", " b", "me", "y ", "en", "it", "ar", "ll", "ea", "I ", "ed", " f", " y", "hi", "is", "es",
/* B */ "or", "l ", " c", "ne", "'s", "nd", "le", "se", " I", "a ", "te", " l", "pe", "as", "ur", "u ",
/* C */ "al", " p", "g ", "om", " d", "f ", " g", "ow", "rs", "be", "ro", "us", "ri", "wa", "we", "Wh",
/* D */ "et", " r", "nt", "m ", "ma", "I'", "li", "ho", "of", "Yo", "h ", " n", "ee", "de", "so", "gh",
/* E */ "ca", "ra", "n'", "ta", "ut", "el", "! ", "fo", "ti", "We", "lo", "e!", "ld", "no", "ac", "ce",
/* F */ "k ", " u", "oo", "ke", "ay", "w ", "!!", "ag", "il", "ly", "co", ". ", "ch", "go", "ge", "e_"
};

DialogueItem::DialogueItem()
{
}

DialogueItem::~DialogueItem()
{
	if(length != 0 && text) delete text;
}

void DialogueItem::ConvertToASCII(CString& str, DWORD tag, DWORD value, ... )
{
	DWORD propTag = tag;
	DWORD propValue = value;
	CMap<DWORD, DWORD, DWORD, DWORD> tagColl;

	va_list marker;
	va_start(marker, value);
	while(propTag != TAG_END)
	{
		tagColl[propTag] = propValue;
		propTag = va_arg(marker, DWORD);
		propValue = va_arg(marker, DWORD);
	}
	va_end(marker);

	BOOL bTagFound = FALSE;
	DWORD dwValue = 0;

	DWORD dwMode = 0;
	bTagFound = tagColl.Lookup(DI_ConvertMode, dwValue);
	if(bTagFound)
		dwMode = (DWORD)dwValue;
	else
		return;

	int nOffset = 0;
	bTagFound = tagColl.Lookup(DI_Offset, dwValue);
	if(bTagFound)
		nOffset = (int)dwValue;
	else
		nOffset = 0;

	str.Empty();

	if(text == NULL)
	{
		if(dwMode == DICM_List)
			str = "<Empty>";
		else
			str.Empty();

		return;
	}

	for(int i = nOffset; i < length; i++)
	{
		if(text[i] >= 0x20 && text[i] <= 0x39) str += text[i] + 0x21;
		else if(text[i] >= 0x3A && text[i] <= 0x53) str += text[i] + 0x27;
		else if(text[i] >= 0x54 && text[i] <= 0x5D) str += text[i] - 0x24;

		else if(text[i] >= 0x80 && text[i] <= 0xFF) str += g_dteTable[text[i] - 0x80];

		else if(text[i] == 0x5E) str += "!";
		else if(text[i] == 0x5F) str += "?";
		else if(text[i] == 0x60) str += "/";
		else if(text[i] == 0x61) str += ":";
		else if(text[i] == 0x62) str += "$";			// $ is the right quote in FF3.FNT
		else if(text[i] == 0x63) str += "'";
		else if(text[i] == 0x64) str += "-";
		else if(text[i] == 0x65) str += ".";
		else if(text[i] == 0x66) str += ",";
		else if(text[i] == 0x67) str += "_";			// _ is the ellipsis
		else if(text[i] == 0x68) str += ";";
		else if(text[i] == 0x69) str += "#";
		else if(text[i] == 0x6A) str += "+";
		else if(text[i] == 0x6B) str += "(";
		else if(text[i] == 0x6C) str += ")";
		else if(text[i] == 0x6D) str += "%";
		else if(text[i] == 0x6E) str += "~";
		else if(text[i] == 0x6F) str += "*";
		else if(text[i] == 0x70) str += "@";
		else if(text[i] == 0x71) str += "&";			// & is the musical note
		else if(text[i] == 0x72) str += "=";
		else if(text[i] == 0x73) str += "\"";
		else if(text[i] == 0x7F) str += " ";

		else if(text[i] == 0x01 && dwMode == DICM_List) str += " ";
		else if(text[i] == 0x01 && dwMode == DICM_Edit) str += "\r\n";
		else if(text[i] == 0x13 && dwMode == DICM_List) str += " ";
		else if(text[i] == 0x13 && dwMode == DICM_Edit) str += "<P>\r\n";
		else if(text[i] == 0x15) str += "^";			// ^ is the multiple choice indicator

		else if(text[i] == 0x19) str += "<N>";
		else if(text[i] == 0x1A) str += "<I>";
		else if(text[i] == 0x1B) str += "<S>";

		else if(text[i] == 0x02 && dwMode == DICM_List) str += "TERRA";
		else if(text[i] == 0x03 && dwMode == DICM_List) str += "LOCKE";
		else if(text[i] == 0x04 && dwMode == DICM_List) str += "CYAN";
		else if(text[i] == 0x05 && dwMode == DICM_List) str += "SHADOW";
		else if(text[i] == 0x06 && dwMode == DICM_List) str += "EDGAR";
		else if(text[i] == 0x07 && dwMode == DICM_List) str += "SABIN";
		else if(text[i] == 0x08 && dwMode == DICM_List) str += "CELES";
		else if(text[i] == 0x09 && dwMode == DICM_List) str += "STRAGO";
		else if(text[i] == 0x0A && dwMode == DICM_List) str += "RELM";
		else if(text[i] == 0x0B && dwMode == DICM_List) str += "SETZER";
		else if(text[i] == 0x0C && dwMode == DICM_List) str += "MOG";
		else if(text[i] == 0x0D && dwMode == DICM_List) str += "GAU";
		else if(text[i] == 0x0E && dwMode == DICM_List) str += "GOGO";
		else if(text[i] == 0x0F && dwMode == DICM_List) str += "UMARO";

		else if(text[i] == 0x02 && dwMode == DICM_Edit) str += "<C 1>";
		else if(text[i] == 0x03 && dwMode == DICM_Edit) str += "<C 2>";
		else if(text[i] == 0x04 && dwMode == DICM_Edit) str += "<C 3>";
		else if(text[i] == 0x05 && dwMode == DICM_Edit) str += "<C 4>";
		else if(text[i] == 0x06 && dwMode == DICM_Edit) str += "<C 5>";
		else if(text[i] == 0x07 && dwMode == DICM_Edit) str += "<C 6>";
		else if(text[i] == 0x08 && dwMode == DICM_Edit) str += "<C 7>";
		else if(text[i] == 0x09 && dwMode == DICM_Edit) str += "<C 8>";
		else if(text[i] == 0x0A && dwMode == DICM_Edit) str += "<C 9>";
		else if(text[i] == 0x0B && dwMode == DICM_Edit) str += "<C 10>";
		else if(text[i] == 0x0C && dwMode == DICM_Edit) str += "<C 11>";
		else if(text[i] == 0x0D && dwMode == DICM_Edit) str += "<C 12>";
		else if(text[i] == 0x0E && dwMode == DICM_Edit) str += "<C 13>";
		else if(text[i] == 0x0F && dwMode == DICM_Edit) str += "<C 14>";

		else if((text[i] == 0x10 || text[i] == 0x12) && dwMode == DICM_List) ;
		else if(text[i] == 0x00) ;

		else if(text[i] == 0x10 && dwMode == DICM_Edit) str += "<D>";

		else if(text[i] == 0x14 && dwMode == DICM_List)
		{
			i++;
		}
		else if(text[i] == 0x14 && dwMode == DICM_Edit)
		{
			i++;
			BYTE param = text[i];

			CString t;  t.Format("<T %d>", param);
			str += t;
		}

		else if((text[i] == 0x11 || text[i] == 0x16) && dwMode == DICM_List)
		{
			i++;
			while(text[i] != 0x12)
				i++;			
		}
		else if(text[i] == 0x16 && dwMode == DICM_Edit)
		{
			CString t;
			i++;
			BYTE param = text[i];

			t.Format("<WS %d", param);

			while(text[i] != 0x12)
			{
				str += t;

				i++;
				param = text[i];
				t.Format(", %d", param);
			}

			str += ">";
		}
		else if(text[i] == 0x11 && dwMode == DICM_Edit)
		{
			CString t;
			i++;
			BYTE param = text[i];

			t.Format("<WT %d", param);

			while(text[i] != 0x12)
			{
				str += t;

				i++;
				param = text[i];
				t.Format(", %d", param);
			}

			str += ">";
		}

		else
		{
			CString t;
			t.Format("<%02X>", text[i]);
			str += t;
		}
	}
}

CString FixedTextToCString(BYTE* text, int length, DWORD tag, DWORD value, ... )
{
	DWORD propTag = tag;
	DWORD propValue = value;
	CMap<DWORD, DWORD, DWORD, DWORD> tagColl;

	va_list marker;
	va_start(marker, value);
	while(propTag != TAG_END)
	{
		tagColl[propTag] = propValue;
		propTag = va_arg(marker, DWORD);
		propValue = va_arg(marker, DWORD);
	}
	va_end(marker);

	BOOL bTagFound = FALSE;
	DWORD dwValue = 0;

	BOOL bTrim = 0;
	bTagFound = tagColl.Lookup(TTCS_TrimTrailingSpaces, dwValue);
	if(bTagFound)
		bTrim = (BOOL)dwValue;
	else
		bTrim = FALSE;

	CString str;

	for(int i = 0; i < length; i++)
	{
		if(text[i] >= 0x80 && text[i] <= 0x99) str += text[i] - 0x3F;
		else if(text[i] >= 0x9A && text[i] <= 0xB3) str += text[i] - 0x39;
		else if(text[i] >= 0xB4 && text[i] <= 0xBD) str += text[i] - 0x84;

		else if(text[i] == 0xBE) str += "!";
		else if(text[i] == 0xBF) str += "?";
		else if(text[i] == 0xC0) str += "/";
		else if(text[i] == 0xC1) str += ":";
		else if(text[i] == 0xC2) str += "\"";
		else if(text[i] == 0xC3) str += "'";
		else if(text[i] == 0xC4) str += "-";
		else if(text[i] == 0xC5) str += ".";
		else if(text[i] == 0xC6) str += ",";
		else if(text[i] == 0xC7) str += "_";
		else if(text[i] == 0xC8) str += ";";
		else if(text[i] == 0xC9) str += "#";
		else if(text[i] == 0xCA) str += "+";
		else if(text[i] == 0xCB) str += "(";
		else if(text[i] == 0xCC) str += ")";
		else if(text[i] == 0xCD) str += "%";
		else if(text[i] == 0xCE) str += "~";
		else if(text[i] == 0xCF) str += "*";
		else if(text[i] == 0xD2) str += "=";
		else if(text[i] == 0xD3) str += "@";
		else if(text[i] == 0xD7) str += "$";
		else if(text[i] == 0xFE) str += " ";
		else if(text[i] == 0xFF) str += " ";

		else
		{
			CString t;
			t.Format("<%02X>", text[i]);
			str += t;
		}
	}

	return str;
}